import { useState, useEffect, Fragment } from 'react'
import './App.css'
import {createBrowserHistory} from 'history';
import {Router, Link} from 'react-router-dom'
import {createQueryPub, NamedRoute, NamedLink, usePub} from './lib';
import {MetaPlate} from './lib';

import {createQueryRoutes, createPub} from './lib';

/*
  CREATE QUERY ROUTE HUGE CONFIGURATION SAMPLE/TEST
 */

const history = createBrowserHistory()

const shopUrl = 'http://shop-roles.node.ed.asmer.org.ua/'

const gql = (query, variables={}) => 
    fetch(shopUrl + 'graphql',{
        method: 'POST',
        headers: {
            'Content-Type': 'application/json',
            Accept: 'application/json',
            ...(authPub.token ? 
             { Authorization: 'Bearer ' + authPub.token } : {})
        },
        body: JSON.stringify({query, variables})
    })
    .then(res => res.json())
    .then(result => {
        if (result.errors && !result.data){
            throw new Error(JSON.stringify(result.errors))
        }
        return Object.values(result.data)[0]
    })

const LeftMenu = ({data}) => {
    return (
        <ul>
                <MetaPlate data={data}>
                    <>
                        <LeftMenuItem prop="category" keyDataKey="_id"/>
                    </>
                </MetaPlate>
        </ul>
    )
}














//const {queryPub, createQuery, withQueryFunc} = createQueryPub({
    //queryFunc: gql,
    //cacheTimeout: 5000,
//})

//const {useCategoriesQuery} = createQuery({
    //promiseName: 'categories',
    //args: [`query MainCategories{
              //CategoryFind(query: "[{}]"){
                //_id name
                  //image{
                    //url
                  //}
                //goods{
                //_id
                //name description price images{
                  //url
                //}
              //}
              //subCategories{ name _id}
            //}
        //}
    //`]
//})

//const {useMainCategoriesQuery} = createQuery({
    //promiseName: 'mainCategories',
    //args: [`query MainCategories{
              //CategoryFind(query: "[{\\"parent\\":null}]"){
                //_id name
                  //image{
                    //url 
                  //}
                //goods{
                //_id
                //name description price images{
                  //url
                //}
              //}
              //subCategories{ name _id}
            //}
        //}
    //`]
//})


//const {query: categoryQuery, useCategoryQuery} = createQuery({
    //promiseName: 'category',
    //args: ({_id}) => [`query categoryById($query:String){
              //CategoryFindOne(query: $query){
                //_id name
                  //image{
                    //url
                  //}
                //goods{
                //_id
                //name description price images{
                  //url
                //}
              //}
              //subCategories{ name _id}
            //}
        //}
    //`, {query: JSON.stringify([{_id}])}]
//})


//queryPub.subscribe(() => console.log(JSON.stringify(queryPub.queries.user, null, 4)))
//



const Image = ({src}) => <img src={`${shopUrl}${src}`} style={{maxWidth: '50%'}}/>

const Good = ({good, children}) => {
    //useEffect(() => {
        //console.log('good mount', good.name)
    //},[])
    return (
        good ? 
            <div className='Good'>
                <h2>{good.name}</h2>
                <p>{good.description}</p>
                <span>{good.price}</span>
                {children}
            </div>
        : <h3>null</h3>
    )
}

const Category = ({category:{name, _id}, children}) =>
<div className='Category'>
    <h1>{name}</h1>
    {_id}
    {children}
</div>

const Categories = ({children, data}) => 
<div style={{border: '2px solid', paddingLeft: '20px'}}>
    <h1>categories({data && data.length})</h1>
    {children}
</div>

const Goods = ({children}) => 
<div style={{border: '2px solid blue', paddingLeft: '10px'}}>
    <h2>goods</h2>
    {children}
</div>

const PageCategory = ({data}) => {
    console.log('page category update',data)
    return (
    <>
        <MetaPlate data={data}>
            <Category prop="category" keyDataKey="_id">
                <Goods sourceDataKey="goods"> 
                    <Good prop="good" keyDataKey="_id">
                        <div sourceDataKey="images">
                            <Image prop="src" sourceDataKey="url"/>
                        </div>
                    </Good>
                </Goods>
                <Categories sourceDataKey="subCategories" prop='data'>
                    <LeftMenuItem prop="category" keyDataKey="_id" />
                </Categories>
            </Category>
        </MetaPlate> 
    </>
    )
}

const LeftMenuItem = ({category:{_id,name}})=>
<li><CategoryLink params={{_id}}>{name}</CategoryLink></li>
//<li><NamedLink name="category" params={{_id}}>{name}</NamedLink></li>
//<li><Link  to={`/category/${_id}`}>{name}</Link></li>
//
//

const Order = ({order: {createdAt, total}, children}) =>
<div style={{border: '2px solid black', margin: '30px'}}>
    {console.log(+createdAt)}
    <h2>{(new Date(+createdAt)).toDateString()} - {total}</h2>
    {children}
</div>

const OrderGood = ({orderGood: {good, total, count, price}}) =>
<div style={{border: '1px dashed gray'}}>
    {console.log(good.images)}
    <h3>{good.name}</h3>
    <Image src={good.images?.[0]?.url} />
    <h4>{price} x {count} = {total}</h4>
</div>


const PageOrders = ({data}) => {
    console.log('orders page', data[0])
    return (
        <MetaPlate data={data}>
            <>
                <Order prop="order" keyDataKey="_id">
                    <Fragment sourceDataKey="orderGoods">
                        <OrderGood prop="orderGood" />
                    </Fragment>
                </Order>
            </>
        </MetaPlate>
    )
}
    /*
        <MetaPlate data={data}>
            <Category prop="category" keyDataKey="_id">
                <Goods sourceDataKey="goods"> 
                    <Good prop="good" keyDataKey="_id">
                        <div sourceDataKey="images">
                            <Image prop="src" sourceDataKey="url"/>
                        </div>
                    </Good>
                </Goods> */

const queryRouteResult = createQueryRoutes({
    query: gql,
    Pending: () => <h1>Loading...</h1>,
    //cacheTimeout: 5000,
    hidePendingOnRefresh: true,
    getUserRoles: () => authPub.decoded?.sub.acl,
    fallback: history => history.goBack(),
    queryRoutes: {
        index: {
            path: '/',
            args: [`query MainCategories{
                      CategoryFind(query: "[{\\"parent\\":null}]"){
                        _id name
                          image{
                            url 
                          }
                        goods{
                        _id
                        name description price images{
                          url
                        }
                      }
                      subCategories{ name _id}
                    }
                }
            `],
            component: LeftMenu,
            //cacheTimeout: 10_000 //override works
        },
        category: {
            path: '/category/:_id',
            args: ({_id}) => [`query categoryById($query:String){
                      CategoryFindOne(query: $query){
                        _id name
                          image{
                            url
                          }
                        goods{
                        _id
                        name description price images{
                          url
                        }
                      }
                      subCategories{ name _id}
                    }
                }
            `, {query: JSON.stringify([{_id}])}],
            component: PageCategory
        },
        login: {
            isMutation: true,
            args: ({login, password}) => [`query login ($login:String, $password: String){
                login(login:$login, password: $password)
            }`, {login, password}]
        },
        user: {
            args: ({_id}) => [`query userById($query:String){
                      UserFindOne(query: $query){
                        _id login nick
                        avatar { url }
                    }
                }
            `, {query: JSON.stringify([{_id}])}],
            cacheTagsFunc: ({_id}) => ({id: _id, type: 'User'})
        },
        myOrders: {
            path: '/orders',
            roles: ['user'],
            args: [`query Orders{
                      OrderFind(query: "[{}]"){
                        _id total
                        createdAt
                        orderGoods{
                            good {
                                _id name
                                images { url }
                            }
                            count
                            total
                            price
                        }
                    }
                }
            `],
            component: PageOrders,
        },
        setNick: {
            isMutation: true,
            args: ({_id, nick}) => [`mutation setNick ($_id:String, $nick: String){
                UserUpsert(user: {_id: $_id, nick: $nick}){
                    _id nick
                }
            }`, {_id, nick}],
            cacheTagsFunc: (payload, [{_id}]) => ({id: _id, type: 'User'})
        }
    }
})


const { AllRoutes, 
        queryRoutes: 
            {
                category: {CategoryLink}, 
                login: {useLoginMutation, query: loginQuery},
                user: {query: userQuery},
                myOrders: {MyOrdersLink},
                setNick: {query: setNickQuery}
            }, 
        queryPub, withQueryFunc, flushCache } = queryRouteResult


const authPub = createPub()
const jwtDecode = token => {
    try {
        return JSON.parse(atob(token.split('.')[1]))
    }
    catch{ }
}

const thunkSetNick = async ({nick}) => {
    if (!authPub.decoded?.sub?.id) return

    const _id = authPub.decoded.sub.id
    const setNickResult = await setNickQuery({_id, nick})

    await thunkAboutMe()
}

const actionLogout = () => {
    authPub.login = null
    authPub.token = null;
    authPub.user = null;
    authPub.decoded = null

    flushCache()
}

const thunkAboutMe = async () => {
    if (!authPub.decoded?.sub?.id) return

    const myUser = await userQuery({_id: authPub.decoded.sub.id})
    if (!myUser.payload){
        actionLogout()
        return;
    }
    authPub.user = myUser.payload
}

const thunkLogin = async ({login, password}) => {
    const loginResult = await loginQuery({login, password})
    if (!loginResult || !loginResult?.payload){
        actionLogout()
        return;
    }
    const token = loginResult.payload
    const decoded = jwtDecode(token)
    if (!decoded){
        actionLogout()
        return;
    }

    authPub.login = decoded.sub.login
    authPub.token = token
    authPub.decoded = decoded


    flushCache()

    await thunkAboutMe()
}

//authPub.subscribe(() => console.log(JSON.stringify(authPub, null, 4)))


const LoginForm = () => {
    const [login, setLogin] = useState('tst17')
    const [password, setPassword] = useState('123123')

    return (
        <div>
            <input value={login} onChange={e => setLogin(e.target.value)} />
            <input value={password} onChange={e => setPassword(e.target.value)} />
            <button onClick={() => thunkLogin({login, password})}>Login...</button>
        </div>
    )
}

const SetNickForm = () => {
    usePub(authPub);

    const [nick, setNick] = useState('')
    useEffect(() => { 
        setNick(authPub.user?.nick || '')
    }, [authPub.user?.nick])

    if (!authPub.token) return null

    return (
        <div>
            <input value={nick} onChange={e => setNick(e.target.value)}/>
            <button onClick={() => thunkSetNick({nick})}>Save new nick</button>
        </div>
    )
}

const LogoutButton = () => {
    usePub(authPub)
    if (!authPub.login) return null;
    return (
        <button onClick={actionLogout}>{authPub.user?.nick || authPub.login} (logout)</button>
    )
}


//works okay
//const LoginForm = () => {
    //const [login, setLogin] = useState('')
    //const [password, setPassword] = useState('')

    //const [loginQuery, data] = useLoginMutation()
    //console.log(loginQuery, data);
    //return (
        //<div>
            //<input value={login} onChange={e => setLogin(e.target.value)} />
            //<input value={password} onChange={e => setPassword(e.target.value)} />
            //<button onClick={() => loginQuery({login, password})}>Login...</button>
        //</div>
    //)
//}

queryPub.subscribe(() => console.log(/*queryPub,*/ JSON.stringify(queryPub.queries.user, null, 4)))

function App() {
    //const {payload} = useCategoriesQuery()
    //console.log('update', performance.now())
    //useEffect(() => console.log('effect',performance.now()), [payload])
    return (
        <Router history={history}>
            <MyOrdersLink>Orders</MyOrdersLink>
            <LogoutButton/>
            <LoginForm />
            <SetNickForm />
            <AllRoutes />




            {/*payload && 
            <MetaPlate data={payload.data.CategoryFind}>
                <Categories prop='data'>
                    <Category prop="category" keyDataKey="_id">
                        <Goods sourceDataKey="goods"> 
                            <Good prop="good" keyDataKey="_id">
                                <div sourceDataKey="images">
                                    <Image prop="src" sourceDataKey="url"/>
                                </div>
                            </Good>
                        </Goods>
                        <Categories sourceDataKey="subCategories" prop='data'>
                            <Category prop="category" keyDataKey="_id" />
                        </Categories>
                    </Category>
                </Categories>
            </MetaPlate> */ }
        </Router>
    )
}

export default App
